<?php

include_once(dirname(__FILE__).'/MimeTypes.php');

class File extends Module
{
  var $FilesDir;
  
  function __construct($System) 
  {
    parent::__construct($System);
    $this->FilesDir = '';
  }
  
  function Delete($Id)
  {
    $DbResult = $this->Database->select('File', 'Name', 'Id='.$Id);
    if($DbResult->num_rows > 0)
    {
      $DbRow = $DbResult->fetch_assoc();   
      $this->Database->delete('File', 'Id='.$Id);
      unlink($this->FilesDir.'/'.$Id.'_'.$DbRow['Name']);
    }
  }
  
  function CreateFromUpload($Name)
  {
    // Submited form with file input have to be enctype="multipart/form-data"
    $Result = 0;
    if(array_key_exists($Name, $_FILES) and ($_FILES[$Name]['name'] != ''))
    {
      if(file_exists($_FILES[$Name]['tmp_name']))
      {
        $FileName = substr($_FILES[$Name]['name'], strrpos($_FILES[$Name]['name'], '/'));
        $this->Database->query('INSERT INTO File (`Name`, `Size`) VALUES ("'.$FileName.'", '.filesize($_FILES[$Name]['tmp_name']).')');
        $InsertId = $this->Database->insert_id;
        if(move_uploaded_file($_FILES[$Name]['tmp_name'], $this->FilesDir.'/'.$InsertId.'_'.$FileName)) $Result = $InsertId;
      }
    }
    return($Result);
  }
  
  function DetectMimeType($FileName)
  {
  	global $MimeTypes;
  	
    $Result = $MimeTypes[pathinfo($FileName, PATHINFO_EXTENSION)][0];
    return($Result);
  }

  function Download($Id)
  {
    $DbResult = $this->Database->select('File', '*', 'Id='.addslashes($Id));
    if($DbResult->num_rows > 0)
    {
      $DbRow = $DbResult->fetch_assoc();
      if($DbRow['Directory'] != '') $FileName = $this->GetDir($DbRow['Directory']);
        else $FileName = $this->FilesDir;
      $FileName .= $DbRow['Name'];
      if(file_exists($FileName))
      {
        Header('Content-Type: '.$this->DetectMimeType($FileName));
        Header('Content-Disposition: attachment; filename="'.$DbRow['Name'].'"');
        echo(file_get_contents($FileName));
      } else echo('Soubor nenalezen!');
    } else echo('Soubor nenalezen!');
  }
  
  function GetDir($Id)
  {
    $DbResult = $this->Database->select('FileDirectory', '*', 'Id='.$Id);
    $DbRow = $DbResult->fetch_assoc();
    if($DbRow['Parent'] != '') $Result = $this->GetDir($DbRow['Parent']);
      else $Result = $this->FilesDir;
    $Result .= $DbRow['Name'].'/';
    return($Result);
  }
}


class PageFile extends Page
{
  function Show()
  {
    if(array_key_exists('id', $_GET)) $Id = $_GET['id'];
    else if(array_key_exists('i', $_GET)) $Id = $_GET['i'];
    else return($this->SystemMessage('Chyba', 'Nezadáno id dokladu'));
    $this->ClearPage = true;
    $Output = $this->System->Modules['File']->Download($Id);
    return($Output);
  }
}

class ModuleFile extends AppModule
{
  function __construct($System)
  {
    parent::__construct($System);
    $this->Name = 'File';
    $this->Version = '1.0';
    $this->Creator = 'Chronos';
    $this->License = 'GNU/GPLv3';
    $this->Description = 'Base module for file management';
    $this->Dependencies = array();
  }  

  function Install()
  {
    parent::Install();
  }
  
  function Uninstall()
  {     
    parent::Uninstall();
  }
  
  function Start()
  {
    global $Config;
    
    parent::Start();
    $this->System->RegisterPage('file', 'PageFile');
    $this->System->AddModule(new File($this->System));
    $this->System->Modules['File']->FilesDir = dirname(__FILE__).'/../../'.$Config['Web']['UploadFileFolder'];
    $this->System->FormManager->RegisterClass('File', array(
      'Title' => 'Soubor',
      'Table' => 'File',
      'Items' => array(
        'Name' => array('Type' => 'String', 'Caption' => 'Jméno', 'Default' => ''),
        'Directory' => array('Type' => 'TDirectory', 'Caption' => 'Adresář', 'Default' => '', 'Null' => true),
        'Size' => array('Type' => 'Integer', 'Caption' => 'Velikost', 'Default' => ''),
        'Time' => array('Type' => 'DateTime', 'Caption' => 'Čas vytvoření', 'Default' => ''),
      ),
      'ItemActions' => array(
        array('Caption' => 'Stáhnout', 'URL' => '/file'),
      ),
    ));
    $this->System->FormManager->RegisterClass('FileDirectory', array(
      'Title' => 'Adresář souborů',
      'Table' => 'FileDirectory',
      'Items' => array(
        'Name' => array('Type' => 'String', 'Caption' => 'Jméno', 'Default' => ''),
        'Parent' => array('Type' => 'TDirectory', 'Caption' => 'Nadřazený adresář', 'Default' => '', 'Null' => true),
      ),
    ));
    
  }  
  
  function Stop()
  { 
    parent::Stop();    
  } 
}
